Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.gradle
Class StartParameter

    java.lang.Object
      org.gradle.StartParameter

    public class StartParameter

extends Object

`StartParameter` defines the configuration used by a `GradleLauncher` instance to execute a build. The properties of `StartParameter` generally correspond to the command-line options of Gradle. You pass a `StartParameter` instance to `GradleLauncher.newInstance(StartParameter)` when you create a new `Gradle` instance.

You can obtain an instance of a `StartParameter` by either creating a new one, or duplicating an existing one using `newInstance()` or `newBuild()`.

See Also:
  `GradleLauncher`

Nested Class Summary
`static class` | `StartParameter.ShowStacktrace` Specifies the detail to include in stacktraces.

Field Summary
`static File` | `DEFAULT_GRADLE_USER_HOME` The default user home directory.
`static String` | `GRADLE_USER_HOME_PROPERTY_KEY`

Constructor Summary
`StartParameter()` Creates a `StartParameter` with default values.

Method Summary
`void` | `addInitScript(File initScriptFile)` Adds the given file to the list of init scripts that are run before the build starts.
`boolean` | `equals(Object obj)`
`File` | `getBuildFile()` Returns the build file to use to select the default project.
`org.gradle.groovy.scripts.ScriptSource` | `getBuildScriptSource()` Returns the `ScriptSource` to use for the build file for this build.
`CacheUsage` | `getCacheUsage()`
`File` | `getCurrentDir()` Returns the directory to use to select the default project, and to search for the settings file.
`org.gradle.initialization.ProjectSpec` | `getDefaultProjectSelector()` Returns the selector used to choose the default project of the build.
`Set<String>` | `getExcludedTaskNames()` Returns the names of the tasks to be excluded from this build.
`File` | `getGradleUserHomeDir()` Returns the directory to use as the user home directory.
`List<File>` | `getInitScripts()` Returns all explicitly added init scripts that will be run before the build starts.
`LogLevel` | `getLogLevel()`
`File` | `getProjectCacheDir()` Returns the project's cache dir.
`org.gradle.api.internal.artifacts.ProjectDependenciesBuildInstruction` | `getProjectDependenciesBuildInstruction()`
`Map<String,String>` | `getProjectProperties()`
`org.gradle.groovy.scripts.ScriptSource` | `getSettingsScriptSource()` Returns the `ScriptSource` to use for the settings script for this build.
`StartParameter.ShowStacktrace` | `getShowStacktrace()`
`Map<String,String>` | `getSystemPropertiesArgs()`
`List<String>` | `getTaskNames()` Returns the names of the tasks to execute in this build.
`int` | `hashCode()`
`boolean` | `isColorOutput()` Returns true if logging output should be displayed in color when Gradle is running in a terminal which supports color output.
`boolean` | `isContinueOnFailure()` Specifies whether the build should continue on task failure.
`boolean` | `isDryRun()`
`boolean` | `isNoOpt()`
`boolean` | `isProfile()` Returns true if a profile report will be generated.
`boolean` | `isSearchUpwards()`
`StartParameter` | `newBuild()` Creates the parameters for a new build, using these parameters as a template.
`StartParameter` | `newInstance()` Duplicates this `StartParameter` instance.
`void` | `setBuildFile(File buildFile)` Sets the build file to use to select the default project.
`StartParameter` | `setBuildScriptSource(org.gradle.groovy.scripts.ScriptSource buildScript)` Specifies that the given script should be used as the build file for this build.
`void` | `setCacheUsage(CacheUsage cacheUsage)`
`void` | `setColorOutput(boolean colorOutput)` Specifies whether logging output should be displayed in color.
`void` | `setContinueOnFailure(boolean continueOnFailure)` Specifies whether the build should continue on task failure.
`void` | `setCurrentDir(File currentDir)` Sets the directory to use to select the default project, and to search for the settings file.
`void` | `setDefaultProjectSelector(org.gradle.initialization.ProjectSpec defaultProjectSelector)` Sets the selector used to choose the default project of the build.
`void` | `setDryRun(boolean dryRun)`
`void` | `setExcludedTaskNames(Iterable<String> excludedTaskNames)` Sets the tasks to exclude from this build.
`void` | `setGradleUserHomeDir(File gradleUserHomeDir)` Sets the directory to use as the user home directory.
`void` | `setInitScripts(List<File> initScripts)`
`void` | `setLogLevel(LogLevel logLevel)`
`void` | `setNoOpt(boolean noOpt)`
`void` | `setProfile(boolean profile)` Specifies if a profile report should be generated.
`void` | `setProjectCacheDir(File projectCacheDir)` Sets the project's cache location.
`void` | `setProjectDependenciesBuildInstruction(org.gradle.api.internal.artifacts.ProjectDependenciesBuildInstruction projectDependenciesBuildInstruction)`
`void` | `setProjectDir(File projectDir)` Sets the project directory to use to select the default project.
`void` | `setProjectProperties(Map<String,String> projectProperties)`
`void` | `setSearchUpwards(boolean searchUpwards)`
`void` | `setSettingsFile(File settingsFile)` Sets the settings file to use for the build.
`void` | `setSettingsScriptSource(org.gradle.groovy.scripts.ScriptSource settingsScriptSource)` Sets the `ScriptSource` to use for the settings script.
`void` | `setShowStacktrace(StartParameter.ShowStacktrace showStacktrace)`
`void` | `setSystemPropertiesArgs(Map<String,String> systemPropertiesArgs)`
`void` | `setTaskNames(Iterable<String> taskNames)` Sets the tasks to execute in this build.
`String` | `toString()`
`StartParameter` | `useEmbeddedBuildFile(String buildScriptText)` Specifies that the given script should be used as the build file for this build.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### GRADLE_USER_HOME_PROPERTY_KEY

    public static final String GRADLE_USER_HOME_PROPERTY_KEY

See Also:
  Constant Field Values

### DEFAULT_GRADLE_USER_HOME

    public static final File DEFAULT_GRADLE_USER_HOME

  The default user home directory.

Constructor Detail

### StartParameter

    public StartParameter()

  Creates a `StartParameter` with default values. This is roughly equivalent to running Gradle on the command-line with no arguments.

Method Detail

### setProjectCacheDir

    public void setProjectCacheDir(File projectCacheDir)

  Sets the project's cache location. Set to null to use the default location.

  Parameters:
    `projectCacheDir` -

### getProjectCacheDir

    public File getProjectCacheDir()

  Returns the project's cache dir.

  Returns:
    project's cache dir, or null if the default location is to be used.

### newInstance

    public StartParameter newInstance()

  Duplicates this `StartParameter` instance.

  Returns:
    the new parameters.

### newBuild

    public StartParameter newBuild()

  Creates the parameters for a new build, using these parameters as a template. Copies the environmental properties from this parameter (eg gradle user home dir, etc), but does not copy the build specific properties (eg task names).

  Returns:
    The new parameters.

### equals

    public boolean equals(Object obj)

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### getBuildFile

    public File getBuildFile()

  Returns the build file to use to select the default project. Returns null when the build file is not used to select the default project.

  Returns:
    The build file. May be null.

### setBuildFile

    public void setBuildFile(File buildFile)

  Sets the build file to use to select the default project. Use null to disable selecting the default project using the build file.

  Parameters:
    `buildFile` - The build file. May be null.

### getBuildScriptSource

    public org.gradle.groovy.scripts.ScriptSource getBuildScriptSource()

  Returns the `ScriptSource` to use for the build file for this build. Returns null when the default build file(s) are to be used. This source is used for all projects included in the build.

  Returns:
    The build file source, or null to use the defaults.

### getSettingsScriptSource

    public org.gradle.groovy.scripts.ScriptSource getSettingsScriptSource()

  Returns the `ScriptSource` to use for the settings script for this build. Returns null when the default settings script is to be used.

  Returns:
    The settings script source, or null to use the default.

### setSettingsScriptSource

    public void setSettingsScriptSource(org.gradle.groovy.scripts.ScriptSource settingsScriptSource)

  Sets the `ScriptSource` to use for the settings script. Set to null to use the default settings script.

  Parameters:
    `settingsScriptSource` - The settings script source.

### useEmbeddedBuildFile

    public StartParameter useEmbeddedBuildFile(String buildScriptText)

  Specifies that the given script should be used as the build file for this build. Uses an empty settings file.

  Parameters:
    `buildScriptText` - The script to use as the build file.
  Returns:
    this

### setBuildScriptSource

    public StartParameter setBuildScriptSource(org.gradle.groovy.scripts.ScriptSource buildScript)

  Specifies that the given script should be used as the build file for this build. Uses an empty settings file.

  Parameters:
    `buildScript` - The script to use as the build file.
  Returns:
    this

### getTaskNames

    public List<String> getTaskNames()

  Returns the names of the tasks to execute in this build. When empty, the default tasks for the project will be executed.

  Returns:
    the names of the tasks to execute in this build. Never returns null.

### setTaskNames

    public void setTaskNames(Iterable<String> taskNames)

  Sets the tasks to execute in this build. Set to an empty list, or null, to execute the default tasks for the project. The tasks are executed in the order provided, subject to dependency between the tasks.

  Parameters:
    `taskNames` - the names of the tasks to execute in this build.

### getExcludedTaskNames

    public Set<String> getExcludedTaskNames()

  Returns the names of the tasks to be excluded from this build. When empty, no tasks are excluded from the build.

  Returns:
    The names of the excluded tasks. Returns an empty set if there are no such tasks.

### setExcludedTaskNames

    public void setExcludedTaskNames(Iterable<String> excludedTaskNames)

  Sets the tasks to exclude from this build.

  Parameters:
    `excludedTaskNames` - The task names. Can be null.

### getCurrentDir

    public File getCurrentDir()

  Returns the directory to use to select the default project, and to search for the settings file.

  Returns:
    The current directory. Never returns null.

### setCurrentDir

    public void setCurrentDir(File currentDir)

  Sets the directory to use to select the default project, and to search for the settings file. Set to null to use the default current directory.

  Parameters:
    `currentDir` - The directory. Should not be null.

### isSearchUpwards

    public boolean isSearchUpwards()

### setSearchUpwards

    public void setSearchUpwards(boolean searchUpwards)

### getProjectProperties

    public Map<String,String> getProjectProperties()

### setProjectProperties

    public void setProjectProperties(Map<String,String> projectProperties)

### getSystemPropertiesArgs

    public Map<String,String> getSystemPropertiesArgs()

### setSystemPropertiesArgs

    public void setSystemPropertiesArgs(Map<String,String> systemPropertiesArgs)

### getGradleUserHomeDir

    public File getGradleUserHomeDir()

  Returns the directory to use as the user home directory.

  Returns:
    The home directory.

### setGradleUserHomeDir

    public void setGradleUserHomeDir(File gradleUserHomeDir)

  Sets the directory to use as the user home directory. Set to null to use the default directory.

  Parameters:
    `gradleUserHomeDir` - The home directory. May be null.

### getProjectDependenciesBuildInstruction

    public org.gradle.api.internal.artifacts.ProjectDependenciesBuildInstruction getProjectDependenciesBuildInstruction()

### setProjectDependenciesBuildInstruction

    public void setProjectDependenciesBuildInstruction(org.gradle.api.internal.artifacts.ProjectDependenciesBuildInstruction projectDependenciesBuildInstruction)

### getCacheUsage

    public CacheUsage getCacheUsage()

### setCacheUsage

    public void setCacheUsage(CacheUsage cacheUsage)

### isDryRun

    public boolean isDryRun()

### setDryRun

    public void setDryRun(boolean dryRun)

### isNoOpt

    public boolean isNoOpt()

### setNoOpt

    public void setNoOpt(boolean noOpt)

### setSettingsFile

    public void setSettingsFile(File settingsFile)

  Sets the settings file to use for the build. Use null to use the default settings file.

  Parameters:
    `settingsFile` - The settings file to use. May be null.

### addInitScript

    public void addInitScript(File initScriptFile)

  Adds the given file to the list of init scripts that are run before the build starts. This list is in addition to the user init script located in ${user.home}/.gradle/init.gradle.

  Parameters:
    `initScriptFile` - The init script to be run during the Gradle invocation.

### setInitScripts

    public void setInitScripts(List<File> initScripts)

### getInitScripts

    public List<File> getInitScripts()

  Returns all explicitly added init scripts that will be run before the build starts. This list does not contain the user init script located in ${user.home}/.gradle/init.gradle, even though that init script will also be run.

  Returns:
    list of all explicitly added init scripts.

### getLogLevel

    public LogLevel getLogLevel()

### setLogLevel

    public void setLogLevel(LogLevel logLevel)

### getShowStacktrace

    public StartParameter.ShowStacktrace getShowStacktrace()

### setShowStacktrace

    public void setShowStacktrace(StartParameter.ShowStacktrace showStacktrace)

### getDefaultProjectSelector

    public org.gradle.initialization.ProjectSpec getDefaultProjectSelector()

  Returns the selector used to choose the default project of the build. This is the project used as the starting point for resolving task names, and for determining the default tasks.

  Returns:
    The default project. Never returns null.

### setDefaultProjectSelector

    public void setDefaultProjectSelector(org.gradle.initialization.ProjectSpec defaultProjectSelector)

  Sets the selector used to choose the default project of the build.

  Parameters:
    `defaultProjectSelector` - The selector. Should not be null.

### setProjectDir

    public void setProjectDir(File projectDir)

  Sets the project directory to use to select the default project. Use null to use the default criteria for selecting the default project.

  Parameters:
    `projectDir` - The project directory. May be null.

### isColorOutput

    public boolean isColorOutput()

  Returns true if logging output should be displayed in color when Gradle is running in a terminal which supports color output. The default value is true.

  Returns:
    true if logging output should be displayed in color.

### setColorOutput

    public void setColorOutput(boolean colorOutput)

  Specifies whether logging output should be displayed in color.

  Parameters:
    `colorOutput` - true if logging output should be displayed in color.

### setProfile

    public void setProfile(boolean profile)

  Specifies if a profile report should be generated.

  Parameters:
    `profile` - true if a profile report should be generated

### isProfile

    public boolean isProfile()

  Returns true if a profile report will be generated.

### isContinueOnFailure

    public boolean isContinueOnFailure()

  Specifies whether the build should continue on task failure. The default is false.

### setContinueOnFailure

    public void setContinueOnFailure(boolean continueOnFailure)

  Specifies whether the build should continue on task failure. The default is false.

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD